#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Achim Weber 2005
#
# $Id: checkDownloadLimit.pl,v 1.2 2006-11-02 18:46:54 dotzball Exp $
#
#

use strict;

# enable only the following on debugging purpose
use warnings;

require '/var/ipcop/general-functions.pl';
#require "${General::swroot}/lang.pl";
require "${General::swroot}/net-traffic/net-traffic-lib.pl";

my @dummy = (${Traffic::red_in},${Traffic::red_out});
undef(@dummy);

# Debug level:
#	0 - reconnect, no print
#	1 - reconnect, print
#	2 - only print
my $debugLevel = 0;
# Debug

my %config = ();
#&General::readhash("${General::swroot}/net-traffic/limitConfig", \%config);
$config{'ENABLED'} = 'off';
$config{'LOG_ENABLED'} = 'on';
$config{'LIMIT_MB'} = 80;
$config{'SLEEP_SEC'} = 15;

print "DEBUG: debuglevel==$debugLevel - print output\n" if ($debugLevel > 0);

unless (-e "${General::swroot}/red/active")
{
	print "Red is not aktive\n" if ($debugLevel > 0);
	exit 0;
}

if ($config{'ENABLED'} ne 'on')
{
	print "Limit not enabled\n" if ($debugLevel > 0);
	&General::log("Trafficlimit per dial not enabled") if($config{'LOG_ENABLED'} eq 'on');
	exit 0;
}

my $displayMode = "exactTimeframe";

# current time == endtime
my $end = time;

# connect time == starttime
my ($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size,
        $atime, $mtime, $ctime, $blksize, $blocks) = stat("${General::swroot}/red/active");
my $start = $mtime;

my %allDaysBytes = ();
my @allDays = &Traffic::calcTraffic(\%allDaysBytes,$start,$end, $displayMode);

my $total_red_in = 0;
my $total_red_out = 0;

foreach (@allDays) {
	$total_red_in += $allDaysBytes{$_}{${Traffic::red_in}};
	$total_red_out += $allDaysBytes{$_}{${Traffic::red_out}};
}

my $total_red = $total_red_in + $total_red_out;

#$total_red_in = sprintf("%.2f", ($total_red_in/1048576));
#$total_red_out = sprintf("%.2f", ($total_red_out/1048576));
$total_red = sprintf("%.2f", ($total_red/1048576));

print "Limit: $config{'LIMIT_MB'} MB - Reached: $total_red MB\n" if ($debugLevel > 0);

# should we reconnect, have we reached the trafficlimit per dial
if ($config{'LIMIT_MB'} <  $total_red)
{
	print "To much traffic -> reconnect\n" if ($debugLevel > 0);

	if ($debugLevel < 2)
	{
		system('/etc/rc.d/rc.red','stop');
#		system('/etc/rc.d/rc.red','stop');
	}

	if($config{'LOG_ENABLED'} eq 'on') {
		print "Log enabled\n" if ($debugLevel > 0);
		&General::log("Trafficlimit per dial reached. Limit: $config{'LIMIT_MB'} MB - Reached: $total_red MB");
	}

	sleep($config{'SLEEP_SEC'});
	print "Sleeptime: $config{'SLEEP_SEC'} seconds\n" if ($debugLevel > 0);

	system('/etc/rc.d/rc.red','start') if ($debugLevel < 2);
}

exit 0;
