#!/usr/bin/perl
#
# This script restores old Net-Traffic config files
# Target version: Net-Traffic 1.3.0
#
# Copyright (C) 2006 Achim Weber <dotzball@users.sourceforge.net>
#
# $Id: restoreConf.pl,v 1.2 2006-11-02 20:37:29 dotzball Exp $
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

use File::Copy;
use strict;
use warnings;

require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

#my @dummy = ($DATA::defaultServicesFile, $FW::settingsfile);
#undef(@dummy);

my $pathNetTraffHome = "/var/ipcop/net-traffic";

my $path130        = "/var/tmp/nettraffic_conf/1.3.0";

#####
# Main
######

# restore old 1.3.0 config, we only need to copy old/existing files
if (-e $path130)
{
	&copy13($path130, $pathNetTraffHome);
}

exit 0;



sub copy13
{
	my $srcPath = shift;
	my $destPath = shift;

	my @files = ("settings");

	foreach my $file (@files) {
		copy( "$srcPath/$file", "$destPath/$file");
		chmod (0644, "$destPath/$file");
		system ("chown  nobody.nobody $destPath/$file");
	}

	exit 0;
}

